// libg7221_decode.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"
#include "libg7221_decode.h"

struct g7221_handle_s
{
	SirenDecoder decoder_state;
};

// This is an example of an exported function.
LIBG7221_DECODE_API g7221_handle * g7221_init(int bytes_per_frame, int bandwidth)
{
	int sample_rate = bytes_per_frame * 8 * 50;
	if ( sample_rate < 16000 || sample_rate > 48000 ||
		( sample_rate / 800 ) * 800 != sample_rate ||
		( bandwidth != 7000 && bandwidth != 14000 ) )
	{
		return NULL;
	}
	g7221_handle * handle = (g7221_handle *)malloc(sizeof(*handle));
	if ( handle )
	{
		handle->decoder_state = Siren7_NewDecoder( sample_rate, bandwidth == 7000 ? 1 : 2, bytes_per_frame );
		if ( ! handle->decoder_state )
		{
			free( handle );
			handle = NULL;
		}
	}
	return handle;
}

LIBG7221_DECODE_API void g7221_decode_frame(g7221_handle *handle, int16_t *code_words, int16_t *sample_buffer)
{
	if ( handle ) Siren7_DecodeFrame( handle->decoder_state, (unsigned char *)code_words, (unsigned char *)sample_buffer );
}

LIBG7221_DECODE_API void g7221_reset(g7221_handle *handle)
{
	if ( handle ) Siren7_ResetDecoder( handle->decoder_state );
}

LIBG7221_DECODE_API void g7221_free(g7221_handle *handle)
{
	if ( handle ) Siren7_CloseDecoder( handle->decoder_state );
	free( handle );
}
